/*the link has only one lane */

public class Link1 implements TrafficConstants
{
   protected Node1 fromNode;
   protected Node1 toNode;
   protected int length;//# of sites on the link except Nodes
   protected int direct;
	private int passby;	 //# of cars passing the first site of the link
								 // per second, 0 or 1
   private Vehicle[] site;
	   
   public Link1(Node1 fn, Node1 tn,int d,int l)
   {

      fromNode = fn;
      toNode = tn;
  
      direct = d;
      length = l;
		passby = 0;
      
      this.site= new Vehicle[this.length];
		for(int i=0; i<this.length; i++)
         site[i] = null;
   }

	//for situations without periodicall boundary condition
	public Link1(Node1 fn,Node1 tn)
	{
		fromNode = fn;
      toNode = tn;
		int x1=fn.getPosition().x;
		int y1=fn.getPosition().y;
		int x2=fn.getPosition().x;
		int y2=fn.getPosition().y;

		if(x1==x2){
         if(y1<y2){
            direct = SOUTH;
				length=(y2-y1)/siteLength;
         }
         else{
            direct = NORTH;
				length=(y1-y2)/siteLength;
			}
		}
      else if(x1 < x2){
         direct = EAST;
			length=(x2-x1)/siteLength;
      }
      else{
         direct = WEST;
			length=(x1-x2)/siteLength;
		}
		
		passby = 0;
		this.site= new Vehicle[this.length];
		for(int i=0; i<this.length; i++)
         site[i] = null;
	}
      
   public Node1 getFromNode()
   {
      return this.fromNode;
   }
   
   public Node1 getToNode()
   {
      return this.toNode;
   }
   
   public int getDirect()
   {
      return this.direct;
   }
   
   public int getLength()
   {
      return this.length;
   }
   
   public Vehicle getSite(int i)
   {
      return this.site[i];
   }

   public void setSite(Vehicle car, int i)
   {
      this.site[i] = car; 
   }
      
   public void update()
   {  
		int[] moves=new int[length]; 
      for(int i=0;i<length;i++)
		    moves[i] = 0;
 
		passby = 0;
      
      //FOR UPDATE , check the first site
      //leaving from site[0],but update link later
      if(this.site[0]!=null)
		    if(toNode.getStatus() == null && toNode.getForbid() == false){  
				  moves[0] = 1;
              site[0].setVelocity(1);
			 }              
        
      for (int i=1; i < this.length; i++)
         if (site[i] != null)
			    if(site[i-1] == null){
                 site[i].setVelocity(1);
					  moves[i] = 1;
				 }
             
      updateFmNd();
            
      //update
      for (int i=length-1; i>=1; i--)
         if (site[i]!=null)
             if(moves[i] == 1){
                 //move
					 setSite(site[i],i-1);
					 site[i] = null;
             }       
            
      if(moves[0]==1){
         //???update Node now, to avoid collisions
         //?should set v=1 when move in, set v=0 when turning
         this.toNode.setStatus(this.site[0]);
			this.site[0]=null;
			passby = 1;
      }           
   }//end of method of updateLink()

	public void updateFmNd()
	{
		Vehicle car;
		if((car=this.fromNode.getStatus())!= null)
		   //car at node must stay no less than two seconds before it leaves
			if(this.site[length-1] == null && car.getWaitTime() > 1 && 
                 car.getDirection()==this.direct){                       
            car.setVelocity(1);
				setSite(car,length-1);//moving into link
            this.fromNode.setForbid(true);
            this.fromNode.setStatus(null);//leaving from fromNode 
         }
 			
	}

	public int getPassby(){ return passby; }
}
