/*the Link with two lanes */

public class Link2 implements TrafficConstants{
	public Link1[] subLink;
	private int length, direct;
	private int changeLane, passby;

	public Link2(Node2 from,Node2 to,int d,int l)
	{
		this.length=l;
		this.direct=d;
		changeLane = 0;
		passby = 0;
		subLink=new Link1[2];
		for(int i=0;i<2;i++)
			subLink[i]=new Link1(from.subNode[i],to.subNode[i],d,l); //????
	}

	public int getLength(){ return this.length; }
	public int getDirect(){ return this.direct; }
	 
	public void update(){
		resetChangeLane();
		passby = 0;
		int[][] moves=new int[2][length]; 
		for(int i=0;i<length;i++){
		    moves[0][i] = 0; //-1 means changing the lane
			 moves[1][i] = 0;
		}

		/*update the first site of the link
		  no changing lane*/
		Vehicle car;
		for(int i=0;i<2;i++){
			car=subLink[i].getSite(0);
			if(car!=null)
		    	if(subLink[i].getToNode().getStatus() == null 
							&& subLink[i].getToNode().getForbid() == false){  
					moves[i][0] = 1;
               car.setVelocity(1);
				}              
         	
      }//end of for loop

		/* update the rest sites*/
		for(int j=0;j<2;j++)
			for (int i=1; i < this.length; i++){
				car=subLink[j].getSite(i);
         	if(car != null)
				{
			 	   if(subLink[j].getSite(i-1) == null){
          	      car.setVelocity(1);
						moves[j][i] = 1;
					} //move ahead
           	  	else if(i<length-1)//the last site doesn't change lane
				  	   if(subLink[1-j].getSite(i)==null 
				   	&& subLink[1-j].getSite(i-1) == null
						&& subLink[1-j].getSite(i+1) == null){ //change lane
           	   	   moves[j][i]=-1; 
							changeLane++;
						}
					
				//else no moving ahead,no changing lanes
        		}//end of the first if loop
		}//end of update the rest sites i>0

		for(int i=0;i<2;i++)
			subLink[i].updateFmNd();

		for(int i=0;i<2;i++)
			if(moves[i][0]==1){
				car=subLink[i].getSite(0);
				subLink[i].getToNode().setStatus(car);
				subLink[i].setSite(null,0);
				passby++;
			}

		for(int j=0;j<2;j++)
			for (int i=1; i < this.length; i++){
				if(moves[j][i]==1){
					car=subLink[j].getSite(i);
					subLink[j].setSite(car,i-1);
					subLink[j].setSite(null,i);
				}
				else if(moves[j][i]==-1){
					car=subLink[j].getSite(i);
					subLink[1-j].setSite(car,i);
					subLink[j].setSite(null,i);
				 }
			}

	}//end of update

	private void resetChangeLane(){ changeLane = 0; }
	public int getChangeLane(){
		return changeLane;
	}
	public int getPassby() { return passby; }
}
