/*
	Stachastic model, vehicles make turn in nodes randomly
	Every node knows the two directions it directs to.
	Each Node has only one site.
*/

import java.awt.Point;

public class Node1 extends Node{

   public Node1(Point p, float pturn)
   {
      super(p);
      this.pturn = pturn;
		//indicating this node connect to which directions:1 or 2
		connectTo = new boolean[4]; 
		for(int i=0; i<4; i++)
			connectTo[i] = false;
   }

	public void setConnect(int direct,boolean b){
   	connectTo[direct-1] = b;
	}


	public boolean getConnect(int direct){
   	return connectTo[direct-1];
	}


	public void update()
   {
      //when cross==null,forbid==true, car has left to some link, but cars from other links
      //can not move in this cross at same time step (last time step)
      //next time step, when I update nodes, set forbid=false, permit to move in again
      if(this.cross == null && this.forbid==true)
          this.forbid = false;  

      if (this.cross != null){
		    cross.incWaitTime();//increase for all cars staying at nodes
			 
	       if(this.cross.getWaitTime() == 1)//the car just move in last time step
          { 
			 	  if((float)Math.random() <= pturn)              
                 turnDecide();
          }//end of the inner 'if'
            
			 else if(((cross.getWaitTime()/MaxWaitTime)*MaxWaitTime) 
			 			== cross.getWaitTime()){
			 	 turnDecide();  
				 cross.resetWaitTime();//need to consider???
				 cross.incWaitTime();   
			 }

			 //else (don't make turn, forbid=true, stay)	
      }//end of the outter 'if' (if there's a car in the node)        
   }//end of updateNode method

	private void turnDecide(){
		switch (cross.getDirection()){
	      case NORTH:
         {
				if (connectTo[EAST-1])
					cross.setDirection(EAST);
				else if(connectTo[WEST-1])
					cross.setDirection(WEST);
            break;
         }
         case SOUTH:
         {
				if (connectTo[EAST-1])
					cross.setDirection(EAST);
				else if(connectTo[WEST-1])
					cross.setDirection(WEST);
            break;
         }
         case EAST:
         {
				if (connectTo[NORTH-1])
					cross.setDirection(NORTH);
				else if(connectTo[SOUTH-1])
					cross.setDirection(SOUTH);
            break;
         }
         case WEST:
         {
				if (connectTo[NORTH-1])
					cross.setDirection(NORTH);
				else if(connectTo[SOUTH-1])
					cross.setDirection(SOUTH);  
		      break;
         }
       }//end of switch
	}

	protected float pturn; 
	protected boolean[] connectTo;

}