/* Node2 contains 2 subnodes of Node1 type.

*/

import java.awt.Point;

public class Node2 implements TrafficConstants{
	public Node1[] subNode; //permit links access subnodes
	private int directTo; //direction of two subnodes

	public Node2(Point p1, float pturn,int directTo){
		Point p2;
		if(directTo==NORTH || directTo==SOUTH)
			p2=new Point(p1.x,p1.y+siteLength);
		else
			p2=new Point(p1.x+siteLength,p1.y);

		subNode = new Node1[2];
		subNode[0] = new Node1(p1,pturn);
		subNode[1] = new Node1(p2,pturn);
		this.directTo=directTo;
	}

	public Node2(Node1 n1, Node1 n2, int directTo){
		subNode = new Node1[2];
		subNode[0] = n1;
		subNode[1] = n2;
		this.directTo = directTo; 
	} 


//update each subnode first, then car moving between
//the subNode if applicable
	public void update(){
		
		subNode[0].update();
		subNode[1].update();

		int i;
		if(directTo==EAST || directTo==SOUTH)//same direction with coordinates
			i=0;
		else
			i=1;
		Vehicle car=subNode[i].getStatus();
		if(car!=null)
			if(car.getDirection()==directTo && car.getWaitTime()>1)
				if(subNode[1-i].getStatus()==null && subNode[1-i].getForbid()==false){
					car.setVelocity(1);
					subNode[1-i].setStatus(car);
					subNode[1-i].setForbid(true);
					subNode[i].setStatus(null);
					subNode[i].setForbid(true);
				}
	}

}
