import javax.swing.*;
import java.awt.*;


public class Street extends JPanel implements TrafficConstants{
    private int[] xPoly=new int[7];
	 private int[] yPoly=new int[7];
   
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.setColor(Color.black);
        g.drawRect(10,10,XBlock*Bx,YBlock*By); 

		  g.setColor(Color.white);
		  int x0=210, y0=10;
		  while(x0<XBlock*Bx){
		  		while(y0<YBlock*By){
					g.drawLine(x0,y0,x0,y0+15);
					y0 += 30;
				}
				x0 += Bx;
				y0 = 10;
		  }
        //180*140 for each block,
        //9 sites along horizontial,7 sites along vertical streets
		  //Vertical streets are two lanes
        int blkWidth=Lx*siteLength, blkHeight=Ly*siteLength;
        int x=10, y=10;
        g.setColor(Color.gray);
        while (x<XBlock*Bx+10) {
           while (y<YBlock*By+10) {
                g.fillRect(x,y,blkWidth,blkHeight);
                y += blkHeight + siteLength;
           }
           x += blkWidth + siteLength*2;
           y=10;
        } 

		  g.setColor(Color.white); //draw arrows
		  for(int i=0;i<XBlock/2;i++){
		  		x0=Bx-10+Bx*(2*i+1)-48;
		  		for(int j=0;j<YBlock;j++){
					y0=10+j*By;
					defNArrow(x0,y0);
		  			g.fillPolygon(xPoly,yPoly,7);
				}
		  }
		 for(int i=0;i<XBlock/2;i++){
		  	x0=10+Bx*(2*i+1)-68;
			for(int j=0;j<YBlock;j++){
				y0=10+j*By;
				defSArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		 }  
		for(int i=0;i<YBlock/2;i++){
		   y0=10+By*(2*i+1)-48;
			for(int j=0;j<XBlock;j++){
				x0=10+Bx*j;
				defEArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		}

		for(int i=0;i<YBlock/2;i++){
		   y0=By+10+By*(2*i+1)-48;
			for(int j=0;j<XBlock;j++){
				x0=10+Bx*j;
				defWArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		}

    }
    
    public Dimension getPreferredSize()
    {
        return new Dimension( XBlock*Bx+20,YBlock*By+20 );
    }
 
    public Dimension getMinimumSize()
    {
        return getPreferredSize();
    }

	 private void defNArrow(int x,int y)
	{
		xPoly[0]=x+14;
		xPoly[1]=x+20;
		xPoly[2]=x+17;
		xPoly[3]=x+17;
		xPoly[4]=x+12;
		xPoly[5]=x+12;
		xPoly[6]=x+8;

		yPoly[0]=y+8;
		yPoly[1]=y+22;
		yPoly[2]=y+22;
		yPoly[3]=y+32;
		yPoly[4]=y+32;
		yPoly[5]=y+22;
		yPoly[6]=y+22;
	}
	
	private void defSArrow(int x,int y)
	{
		xPoly[0]=x+14;
		xPoly[1]=x+20;
		xPoly[2]=x+17;
		xPoly[3]=x+17;
		xPoly[4]=x+12;
		xPoly[5]=x+12;
		xPoly[6]=x+8;

		yPoly[0]=y+32;
		yPoly[1]=y+18;
		yPoly[2]=y+18;
		yPoly[3]=y+8;
		yPoly[4]=y+8;
		yPoly[5]=y+18;
		yPoly[6]=y+18;
	}
  
   private void defEArrow(int x,int y)
	{
		xPoly[0]=x+32;
		xPoly[1]=x+18;
		xPoly[2]=x+18;
		xPoly[3]=x+8;
		xPoly[4]=x+8;
		xPoly[5]=x+18;
		xPoly[6]=x+18;

		yPoly[0]=y+14;
		yPoly[1]=y+20;
		yPoly[2]=y+17;
		yPoly[3]=y+17;
		yPoly[4]=y+12;
		yPoly[5]=y+12;
		yPoly[6]=y+8;
	}   

	private void defWArrow(int x,int y)
	{
		xPoly[0]=x+8;
		xPoly[1]=x+20;
		xPoly[2]=x+20;
		xPoly[3]=x+32;
		xPoly[4]=x+32;
		xPoly[5]=x+20;
		xPoly[6]=x+20;

		yPoly[0]=y+14;
		yPoly[1]=y+20;
		yPoly[2]=y+17;
		yPoly[3]=y+17;
		yPoly[4]=y+12;
		yPoly[5]=y+12;
		yPoly[6]=y+8;
	}   
        
}

