import java.lang.Math;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.Point;

public class Traffic implements TrafficConstants{

    private Node1[][] subNodes;
	 private Node2[][] myNode;
    private Vector hLink, vLink, myCar;
    private int carNo, sumV;
	 private int changeLaneNo, passby;
    
    private int[][] forDraw;
      
    public Traffic(float density,float pturn)
    {
        carNo = 0;
		  sumV = 0;
        subNodes = new Node1[YBlock][XBlock*2];
        myNode = new Node2[YBlock][XBlock];
        vLink = new Vector(); //two-lane links
		  hLink = new Vector();//one-lane links
        myCar = new Vector();
		  changeLaneNo = 0;
		  passby = 0;
        
        int c=0, d=0;
        Vehicle tempCar;
		  Link1 link1;
		  Link2 link2;

		  //the coordinates of a site is the position of its center
        int x0 = 10+Lx*siteLength+siteLength/2;
        int y0 = 10+Ly*siteLength+siteLength/2;     

        for(int i=0;i<YBlock; i++)
           for(int j=0; j<XBlock*2; j++){
           		if(j==j/2*2)
            		subNodes[i][j] = new Node1(new Point(x0+j/2*Bx, y0+i*By),pturn);
					else
						subNodes[i][j] = new Node1(new Point(x0+j/2*Bx+20, y0+i*By),pturn);
           
            	if((float)Math.random()<= density){
               	d++;//chose direction arbitrarily
               	c++;
              		if(d>4) d=d-4;
               	if(c>8) c=c-8;
						tempCar = new Vehicle(0,d,c);
               	myCar.addElement(tempCar);
              		subNodes[i][j].setStatus(tempCar);
               	carNo++;
              	}              
           }  

		  for(int i=0;i<(YBlock/2);i++)
		  	  for(int j=0;j<XBlock;j++){
		  	  		myNode[i*2][j] = new Node2(subNodes[i*2][j*2],subNodes[i*2][j*2+1],EAST);		  
     	     		myNode[i*2+1][j] = new Node2(subNodes[i*2+1][j*2],subNodes[i*2+1][j*2+1],WEST);
			  }

		  for(int i=0;i<(YBlock/2);i++){
				for(int j=0;j<(XBlock-1);j++){
					hLink.addElement(new Link1(subNodes[i*2][j*2+1],subNodes[i*2][j*2+2],EAST,Lx));
					hLink.addElement(new Link1(subNodes[i*2+1][j*2+2],subNodes[i*2+1][j*2+1],WEST,Lx));
				}
				hLink.addElement(new Link1(subNodes[i*2][XBlock*2-1],subNodes[i*2][0],EAST,Lx));
				hLink.addElement(new Link1(subNodes[i*2+1][0],subNodes[i*2+1][XBlock*2-1],WEST,Lx));

				for(int j=0;j<XBlock;j++){
					subNodes[i*2][j*2+1].setConnect(EAST,true);
				   subNodes[i*2+1][j*2].setConnect(WEST,true);
				}
			}  

		
			for(int i=0;i<(XBlock/2);i++){
				for(int j=0;j<(YBlock-1);j++){
					vLink.addElement(new Link2(myNode[j][i*2],myNode[j+1][i*2],SOUTH,Ly));
					vLink.addElement(new Link2(myNode[j+1][i*2+1],myNode[j][i*2+1],NORTH,Ly));
				}
				vLink.addElement(new Link2(myNode[YBlock-1][i*2],myNode[0][i*2],SOUTH,Ly));
				vLink.addElement(new Link2(myNode[0][i*2+1],myNode[YBlock-1][i*2+1],NORTH,Ly));
				
				for(int j=0;j<YBlock;j++)
					for(int k=0;k<2;k++){
						myNode[j][i*2].subNode[k].setConnect(SOUTH,true);
						myNode[j][i*2+1].subNode[k].setConnect(NORTH,true);
					}
			}  

			int l;
			Enumeration e=hLink.elements();
			while(e.hasMoreElements()){
				link1 = (Link1)e.nextElement();
				d=link1.getDirect();
				l=link1.getLength();
				for(int k=0;k<l;k++)
					if((float)Math.random()<=density){
						c++;
						if(c>8) c-=8;
						tempCar=new Vehicle(0,d,c);
						myCar.addElement(tempCar);
						link1.setSite(tempCar,k);
						carNo++;
					}
			}

			e=vLink.elements();
			while(e.hasMoreElements()){
				link2 = (Link2)e.nextElement();
				d=link2.getDirect();
				l=link2.getLength();
				for(int i=0;i<2;i++)
					for(int k=0;k<l;k++)
						if((float)Math.random()<=density){
							c++;
							if(c>8) c-=8;
							tempCar=new Vehicle(0,d,c);
							myCar.addElement(tempCar);
							link2.subLink[i].setSite(tempCar,k);
							carNo++;
						}
			}

			forDraw = new int[carNo][5];
	}//end of constructor

	public int getCarNo(){ return carNo; }

   public int computeForDraw()
   {
      int i,j,k,x0,y0;
      for(i=0;i<carNo; i++)
          for(j=0; j<5; j++)
            forDraw[i][j] =0;
      int n=0;         
      Vehicle car0;
      for(i=0;i<YBlock;i++)
         for(j=0;j<XBlock*2;j++)
            if((car0 = subNodes[i][j].getStatus() )!=null)
            {
               x0 = subNodes[i][j].getPosition().x;
               y0 = subNodes[i][j].getPosition().y;
               forDraw[n][4] = car0.getColor();                 
               if(car0.getDirection()==NORTH || car0.getDirection() ==SOUTH)
               {
                  forDraw[n][0] = x0-carWid/2;
                  forDraw[n][1] = y0-carLen/2;
                  forDraw[n][2] = carWid;
                  forDraw[n][3] = carLen;
               }
               else
               {
                  forDraw[n][0] = x0-carLen/2;
                  forDraw[n][1] = y0-carWid/2;
                  forDraw[n][2] = carLen;
                  forDraw[n][3] = carWid;    
               }
               n++;
            }//end of getting param of car at subNodes[][]  
  
		Link1 link1;
		Enumeration e = hLink.elements();
		while(e.hasMoreElements()){
			link1 = (Link1)e.nextElement();
			n = computeLink(link1,n);
		}
		Link2 link2;
		e = vLink.elements();
		while(e.hasMoreElements()){
			link2 = (Link2)e.nextElement();
			for(i=0;i<2;i++)
				n = computeLink(link2.subLink[i],n);
		}
		return n;
	}

	private int computeLink(Link1 link1, int n){
		int x0,y0,k;
		Vehicle car0;
		x0 = link1.getFromNode().getPosition().x;
		y0 = link1.getFromNode().getPosition().y;

		switch (link1.getDirect())
		{
      case NORTH:{
         x0 -= carWid/2;
         y0 -= carLen/2;  //(x0,y0)is the upper left coner of the car at the fromNode
		
         for(k=link1.getLength()-1; k>=0; k--)
         {
            y0 -=siteLength;
            if((car0=link1.getSite(k)) !=null)
            {
             	forDraw[n][4] = car0.getColor();               
               forDraw[n][0] = x0;
               forDraw[n][1] = y0;
               forDraw[n][2] = carWid;
               forDraw[n][3] = carLen;
               n++;
            }
         }
         break;
      }

		case EAST:{
         if(x0 >= XBlock*Bx-10) x0 -= XBlock*Bx;  //x0=1310; fromNode at East end, BC used
         x0 -= carLen/2;
         y0 -= carWid/2; //(x0,y0)is the upper left coner of the car at the fromNode
		
         for(k=link1.getLength()-1; k>=0; k--)
         {
            x0 +=siteLength;
            if((car0=link1.getSite(k)) !=null)
            {
               forDraw[n][4] = car0.getColor();                 
               forDraw[n][0] = x0;
               forDraw[n][1] = y0;
               forDraw[n][2] = carLen;
               forDraw[n][3] = carWid;
               n++;
            }
         }
         break;
      } 
         
    	case SOUTH:{
         if (y0 >= YBlock*By-10) y0 -= YBlock*By; // y0=960, fromNode at South end, BC used 
         x0 -= carWid/2;
         y0 -= carLen/2; //(x0,y0)is the upper left coner of the car at the fromNode
			
         for(k=link1.getLength()-1; k>=0; k--)
         {
            y0 +=siteLength;
            if((car0=link1.getSite(k)) !=null)
            {
               forDraw[n][4] = car0.getColor();                 
               forDraw[n][0] = x0;
               forDraw[n][1] = y0;
               forDraw[n][2] = carWid;
               forDraw[n][3] = carLen;
               n++;
            }
         }
         break;
      }
		
		case WEST:{
         x0 -= carLen/2;
         y0 -= carWid/2; //(x0,y0)is the upper left coner of the car at the fromNode
		
		   for(k=link1.getLength()-1; k>=0; k--)
         {
            x0 -=siteLength;
            if((car0=link1.getSite(k)) != null)
            {
               forDraw[n][4] = car0.getColor();               
               forDraw[n][0] = x0;
               forDraw[n][1] = y0;
               forDraw[n][2] = carLen;
               forDraw[n][3] = carWid;                              
               n++;
           }
         }
         break;
      }  
      }//end of switch, getting the params of cars in Vector of hLink
       //all elements in hLink are one-lane links
		return n;
	}

	public int getDraw(int i, int j){
      return forDraw[i][j];
   }
	   
   public void updateTraffic()
   {
      int i,j;
      for(i=0;i<YBlock;i++)
         for(j=0;j<XBlock;j++)
            myNode[i][j].update();
		changeLaneNo = 0;
		passby = 0;

		//two-lane links have priority over one-lane links
		Link2 link2;
		Enumeration e = vLink.elements();
		while(e.hasMoreElements()){
			link2 = (Link2)e.nextElement();
			link2.update();
			passby += link2.getPassby();
			changeLaneNo += link2.getChangeLane();
		}
		Link1 link1;
		e = hLink.elements();
		while(e.hasMoreElements()){
			link1 = (Link1)e.nextElement();
			link1.update();
			passby += link1.getPassby();
		} 
   }
   
	public int getSumV(){ 
		Vehicle car;
		sumV = 0;
		Enumeration e = myCar.elements();
		while(e.hasMoreElements()){
			car = (Vehicle)e.nextElement();
			sumV += car.getVelocity();
			car.setVelocity(0); 
		}
		return sumV; 
	}

	public int getChangeLane(){ return changeLaneNo; }
	public float getFlow(){
		 int linkNo;
		 linkNo = hLink.size()+vLink.size();
		 float flow = (float)passby/(float)linkNo;
		 return flow;
	}
}

